class Threads extends Thread {  //die Klasse Threads erbt alle Methoden und Attribute
                                //der Klasse Thread
 boolean running = false; //Attribut zur Kontrolle, ob Thread noch läuft
 int k;
 float[] X;
 float[] Y;
 float[] X1;
 float[] Y1;
 int nummer;
 float[][][] AllMatrices;
 float[][][] MErgebnis;
 float[][][] AllMatrices1;
 float[][][] MErgebnis1;
 double xZ,yZ;//Zufallspunkt aus Def.Bereich
 int konTest = 1000000;//für den Konvergenztest
 

 
public Threads(int tN){
    nummer = tN;
    X = new float[12];
    Y = new float[12];
    X1 = new float[12];
    Y1 = new float[12];
    for(int i =0; i<12;i++){
      X[i] = 0; Y[i] = 0;
      X1[i] = 0; Y1[i] = 0;
    }
   
    MErgebnis = new float[cols][rows][12];
    AllMatrices =new float[cols][rows][12];
    MErgebnis1 = new float[cols][rows][12];
    AllMatrices1 =new float[cols][rows][12];
    for (int k = 0; k<12; k++){
      for (int i = 0; i < cols; i++ ) {
          for (int j = 0; j < rows; j++ ) {
            AllMatrices[i][j][k] = 0;
            MErgebnis[i][j][k] = 0;
            AllMatrices1[i][j][k] = 0;
            MErgebnis1[i][j][k] = 0;
          }
      }
   }
  }
  
//Rückgabe-Methode für Prozess-Nummer
  public int gibNummer(){   
     return nummer;   
   }
// Laufbefehl für den aktuellen Thread 
  public void run(){ 
    running = true;
  //  println("Die interne Threadnummer ist: " 
  //  + Thread.currentThread().getId() + ", Eigene Threadnummer: " + nummer);
    int K = nummer; 
   
    for (int i = 0; i <part; i++) {
      for(int j = 0; j< rows;j++){
        X[K]= minX+K*dK  +i*sW ;   
        Y[K]= minY + j*sW;   
        konvergenzTest(X[K], Y[K], i,(height-1- j), K);      
      }
    }
     
    for (int i = 0; i < cols; i ++ ) {
       for (int j = 0; j < rows; j ++ ) {
         MErgebnis[i][j][K]= AllMatrices[i][j][K];
       }
    }
  //-------------------------------------------------------  
    for (int i = 0; i < n; i++) {
        X1[K]= random(minX,maxX);
        Y1[K]= random(minY+anteil*K, minY+anteil*(K+1));       
        cliffordStart(X1[K], Y1[K], K,bL);//bL: Blinddurchläufe (iter)
    }
    for (int i = 0; i < cols; i ++ ) {
       for (int j = 0; j < rows; j ++ ) {
         MErgebnis1[i][j][K]= AllMatrices1[i][j][K];
       }
    }
   
   println("Thread "+K + " ist beendet");
   
   running = false;
  }  
////////////////////////////////////////////////////////////////////////////  
  void  konvergenzTest(double x0, double y0, int i, int j,int k) {      
    double x = x0;
    double y = y0;
    int I = k*height/anzahlThreads+i; //67 = height/anzahlThreads
    int J = j;
    int l = 0;
    double dAbstandFP1= 0;
    double dAbstandFP2= 0;
    double dAbstandFP3= 0;
    for(l=0; l< konvTestBis; l++){    
       double xt = x;
       double yt = y;
       x =Math.sin(a*yt) + c*Math.cos(a*xt);
       y =Math.sin(b*xt) + d*Math.cos(b*yt); 
       dAbstandFP1 =Math.sqrt((x-fP1x)*(x-fP1x)+(y-fP1y)*(y-fP1y));
       dAbstandFP2 =Math.sqrt((x-fP2x)*(x-fP2x)+(y-fP2y)*(y-fP2y));
       dAbstandFP3 =Math.sqrt((x-fP3x)*(x-fP3x)+(y-fP3y)*(y-fP3y));
       if( dAbstandFP1 < abstand){   
         FPArt[i+k*part][j]=1;
         AllMatrices[I][J][k] =(spreizFaktorKonvergenz*l) % 2048;
         break;
      } 
      else if( dAbstandFP2 < abstand){   
         FPArt[i+k*part][j]=2; 
         AllMatrices[I][J][k] =(spreizFaktorKonvergenz*l) % 2048;
         break;
      } 
     else if( dAbstandFP3 < abstand){   
         FPArt[i+k*part][j]=3;
         AllMatrices[I][J][k] =(spreizFaktorKonvergenz*l) % 2048;
         break;
      }   
     
    }//end of for
  
   if(l== konvTestBis){//print("konvTestBis erreicht ");
      FPArt[i+k*part][j]=4;
      AllMatrices[I][J][k] = 0;     
   }
  }//end of konvergenzTest
//////////////////////////////////////////////////////////////////////////////  
 void cliffordStart(double x0, double y0, int k, int iters) {
  double x = x0;
  double y = y0;
  float xx, yy;
  int XX;
  int YY;
  int K = k;

//Startpunkt dazu
 if(startWerteZeigen){
    xx = (float)x;
    yy = (float)y;
    XX = round( map(xx, -G, G, 0, width));  if(XX>rows-1)XX=rows-1;
    YY = round( map(yy, -G, G, height, 0)); if(YY>cols-1)YY=cols-1;
    AllMatrices1[XX][YY][K]++;  
 }
//
  for (int i = 0; i < iters; i++) {//iters ist die Anzahl der Blindurchläufe
    double xt = x;
    double yt = y;

    x = Math.sin(a*yt) + c*Math.cos(a*xt);
    y = Math.sin(b*xt) + d*Math.cos(b*yt);
  }
  xx =(float)x;
  yy =(float)y;
  XX = round( map(xx, minX, maxX, 0, width));  
  YY = round( map(yy, minY, maxY, height, 0)); 
  if(XX >=0 && XX<cols && YY>=0 && YY<rows) AllMatrices1[XX][YY][K]++;  //nur der letze Term wird genommen
  //sonst außerhalb
  for (int i = iters+1; i < iters+m; i++) {
    double xt = x;
    double yt = y;
    XX=0; YY=0;
    x = Math.sin(a*yt) + c*Math.cos(a*xt);
    y = Math.sin(b*xt) + d*Math.cos(b*yt);
    xx =(float)x;yy=(float)y;
  
    XX = round( map(xx, minX, maxX, 0, width));  
    YY = round( map(yy, minY, maxY, height, 0)); 
    if(XX >=0 && XX<cols && YY>=0 && YY<rows) AllMatrices1[XX][YY][K]++;  
     //sonst außerhalb
  }  
 }
////////////////////////////////////////////////    
}
